# LedgePythonSdk
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 0.0.2
- Generator version: 7.4.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import ledge_python_sdk
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import ledge_python_sdk
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import ledge_python_sdk
from ledge_python_sdk.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = ledge_python_sdk.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with ledge_python_sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ledge_python_sdk.ExternalApi(api_client)
    key = 'key_example' # str | 
    create_goal_request = ledge_python_sdk.CreateGoalRequest() # CreateGoalRequest | 

    try:
        api_response = api_instance.create_goal(key, create_goal_request)
        print("The response of ExternalApi->create_goal:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ExternalApi->create_goal: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ExternalApi* | [**create_goal**](docs/ExternalApi.md#create_goal) | **POST** /external/{key}/goal | 
*ExternalApi* | [**create_quest**](docs/ExternalApi.md#create_quest) | **POST** /external/quests | 
*ExternalApi* | [**create_quest_schedule**](docs/ExternalApi.md#create_quest_schedule) | **POST** /external/{key}/questSchedule | 
*ExternalApi* | [**get_external_user**](docs/ExternalApi.md#get_external_user) | **GET** /external/{key}/external-user | 
*ExternalApi* | [**get_my_goals**](docs/ExternalApi.md#get_my_goals) | **GET** /external/my-goals | 
*ExternalApi* | [**get_my_quests**](docs/ExternalApi.md#get_my_quests) | **GET** /external/my-quests | 
*ExternalApi* | [**register_user**](docs/ExternalApi.md#register_user) | **POST** /external/{key}/user | 
*ExternalApi* | [**track_activity**](docs/ExternalApi.md#track_activity) | **POST** /external/{key}/activity | 


## Documentation For Models

 - [ActivityType](docs/ActivityType.md)
 - [CreateGoalRequest](docs/CreateGoalRequest.md)
 - [CreateQuestRequest](docs/CreateQuestRequest.md)
 - [CreateQuestSchedule200Response](docs/CreateQuestSchedule200Response.md)
 - [CreateQuestScheduleRequest](docs/CreateQuestScheduleRequest.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [ExternalActivity](docs/ExternalActivity.md)
 - [ExternalUser](docs/ExternalUser.md)
 - [Gender](docs/Gender.md)
 - [Goal](docs/Goal.md)
 - [Quest](docs/Quest.md)
 - [QuestSchedule](docs/QuestSchedule.md)
 - [QuestType](docs/QuestType.md)
 - [TrackActivity200Response](docs/TrackActivity200Response.md)
 - [User](docs/User.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="api_key"></a>
### api_key

- **Type**: API key
- **API key parameter name**: access_token
- **Location**: URL query string


## Author




